CON

  _clkmode = xtal1 + pll16x
  _clkfreq = 80_000_000

  BUTTON_PIN = 0
  FIRST_LED = 7
  LEDS_IN_BAR = 7
  LAST_LED = FIRST_LED + LEDS_IN_BAR - 1

  BAUD_115200 = 115200
  
VAR

  long pressTimer, pressPhase, outPattern
  long redFlag

OBJ

  Pst : "Parallax Serial Terminal"
  
PUB Main

  dira[LAST_LED..FIRST_LED] := |< LEDS_IN_BAR - 1

  Pst.Start(BAUD_115200)
  
  repeat
    if redFlag
      DisplayRedFlag
    else
      DisplayNormal
        
    CheckButton
    'do other stuff

PUB CheckButton

  if ina[BUTTON_PIN]
    if pressPhase
      if cnt - pressTimer > clkfreq
        pressTimer += clkfreq
        pressPhase++
        if pressPhase => LEDS_IN_BAR
          redFlag := true
        outPattern <<= 1
        outPattern |= 1
        outa[LAST_LED..FIRST_LED] := outPattern
    else
      outPattern := 1
      pressPhase := 1
      pressTimer := cnt
      outa[LAST_LED..FIRST_LED] := outPattern 
  elseif pressPhase
    pressPhase := 0
    redFlag := false
    outa[LAST_LED..FIRST_LED] := 0

PUB DisplayRedFlag

  Pst.ClearEnd
  Pst.NewLine
  Pst.ClearBelow
  Pst.Home
  Pst.Str(string(11, 13, "Red Flag Active!"))

PUB DisplayNormal

  Pst.ClearEnd
  Pst.NewLine
  Pst.ClearBelow
  Pst.Home
  Pst.Str(string(11, 13, "           LED Bar Program", 11, 13))
  Pst.Str(string(11, 13, "pressPhase = "))
  Pst.Dec(pressPhase)
  if pressPhase
    Pst.Str(string(11, 13, "outPattern = %"))
    Pst.Bin(outPattern, LEDS_IN_BAR)
    